<?php

/**
 * Easygate - Joomla Template
 *
 * @package bt_easygate
 * @version 1.0
 * @copyright BonusThemes.com 2008
 * @link http://www.bonusthemes.com/goto/bt_easygate
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


class TplBtEasygate
{
	var $btlogo = 'on';

	var $header_menu = 'menu';
	var $header_menu_name = 'topmenu';

	var $seocp = 'off';

	function TplBtEasygate()
	{
		$this->__construct();
	}

	function __construct()
	{
		$this->document =& JFactory::getDocument();

		$this->prepare_parameters();
		$this->prepare_path();

		$this->lshow = strtolower($this->btlogo) == 'on';

		$this->seocp = strtolower($this->seocp) == 'on';

		$this->show_menu = $this->header_menu == 'menu';

		if ($this->show_menu)
			$this->load_menu($this->header_menu_name);

		// load zone layout data
		$filename = dirname(__FILE__) . '/zl_config.php';
		$filesize = file_exists($filename) ? filesize($filename) : 0;
		$this->zl_data = false;
		if ($filesize > 0 && $fp = fopen($filename, 'r')) {
			$contents = fread($fp, filesize($filename));
			$this->zl_data = unserialize(substr($contents, strpos($contents, '?>') + 2));
			fclose($fp);
		}

		// load styles
		require(dirname(__FILE__) . '/zl_styles.php');
		$this->gstyles = $gstyles;
		$this->mstyles = $mstyles;


		// prepare miscellaneous variables

		$this->gstyled_pos = array('left', 'right', 'user1', 'user2', 'user3', 'user4');

		$this->gap = isset($this->zl_data['gapsz']) ? $this->zl_data['gapsz'] : 10;
		$this->width = isset($this->zl_data['total_width']) ? $this->zl_data['total_width'] : 960;

		$this->left_panel = $this->modcount('left') || $this->modcount('user1') || $this->modcount('user2');
		$this->right_panel = $this->modcount('right') || $this->modcount('user3') || $this->modcount('user4');

		$this->main_rowspan = $this->left_panel || $this->right_panel ? ' rowspan="3"' : '';

		$colspan = 1;
		if ($this->left_panel)
			$colspan += 4;
		if ($this->right_panel)
			$colspan += 4;
		$this->main_colspan = $colspan == 0 ? '' : ' colspan="' . $colspan . '"';
	}

	function get_home()
	{
		return $this->document->baseurl;
	}

	function prepare_parameters()
	{
		foreach ($this->document->params->_registry[$this->document->params->_defaultNameSpace]['data'] as $k => $v)
			$this->$k = $v;
	}

	function prepare_path()
	{
		$this->path = $this->document->baseurl . '/templates/' . $this->document->template;
	}

	function modcount($position_name)
	{
		static $modules = array();

		if (!isset($modules[$position_name]))
			$modules[$position_name] = $this->document->countModules($position_name);

		return $modules[$position_name];
	}

	function echo_gstyle($gstyle, $type)
	{
		if (!empty($gstyle) && isset($this->gstyles[$gstyle][$type]))
			echo str_replace('[PATH]', $this->path, $this->gstyles[$gstyle][$type]);
	}

	function echo_zones()
	{
		if ($this->zl_data === false) {
			$this->echo_mainbody_wrapper();
		}
		else {
			// filter groups who have existing styles
			foreach ($this->zl_data['groups'] as $k => $v)
				if (!isset($this->gstyles[$v]))
					unset($this->zl_data['groups'][$k]);
	
			$zone_group_manager = unserialize($this->zl_data['zones_obj']);
			$zone_group_manager->cleanup($this);
	
			$zone_group_first = true;
			foreach ($zone_group_manager->groups as $zone_group) {
				if ($zone_group_first)
					$zone_group_first = false;
				else
					echo '<div class="gap"></div>' . "\n";
	
				$zone_group_style = (string) @$this->zl_data['groups'][$zone_group->name];
				$this->echo_gstyle($zone_group_style, 'open');
	
				$zone_first = true;
				foreach ($zone_group->zones as $zone) {
					if ($zone_first)
						$zone_first = false;
					else
						echo '<div class="gap"></div>' . "\n";
	
					$zone_style = isset($this->gstyles[$zone->style]) ? $zone->style : '';
					$this->echo_gstyle($zone_style, 'open');
	
					$zone_multi = count($zone->groups) > 1;
					if ($zone_multi)
						echo '<table cellspacing="0" cellpadding="0" width="100%"><tr>' . "\n";
	
					$pos_group_first = true;
					foreach ($zone->groups as $pos_group) {
						if ($pos_group_first)
							$pos_group_first = false;
						else
							echo '	<td><div class="gap"></div></td>' . "\n";
	
						if ($zone_multi)
							echo '	<td valign="top">' . "\n";
	
						$pos_group_style = (string) @$this->zl_data['groups'][$pos_group->name];
						$this->echo_gstyle($pos_group_style, 'open');
	
						$pos_group_multi = count($pos_group->positions) > 1;
						if ($pos_group_multi)
							echo '<table cellspacing="0" cellpadding="0" width="100%"><tr>' . "\n";
	
						$pos_first = true;
						foreach ($pos_group->positions as $pos) {
							if ($pos_first)
								$pos_first = false;
							else
								echo '	<td><div class="gap"></div></td>' . "\n";
	
							if ($pos_group_multi)
								echo '	<td valign="top">' . "\n";
	
							$pos_style = isset($this->gstyles[$pos->style]) ? $pos->style : '';
							$this->echo_gstyle($pos_style, 'open');
	
							if ($pos->width !== null) {
								$var = $pos->name == '' ? 'mainbody_width' : 'pos_' . $pos->name . '_width';
								$this->$var = $pos->width;
							}
	
							if ($pos->name == '')
								$this->echo_mainbody_wrapper();
							else
								$this->echo_position($pos->name, true);
	
							$this->echo_gstyle($pos_style, 'close');
	
							if ($pos_group_multi)
								echo '	</td>' . "\n";
						}
	
						if ($pos_group_multi)
							echo '</tr></table>' . "\n";
	
						$this->echo_gstyle($pos_group_style, 'close');
	
						if ($zone_multi)
							echo '	</td>' . "\n";
					}
	
					if ($zone_multi)
						echo '</tr></table>' . "\n";
	
					$this->echo_gstyle($zone_style, 'close');
				}
	
				$this->echo_gstyle($zone_group_style, 'close');
			}
		}
	}

	function echo_hidden_position($position_name)
	{
		if ($this->modcount($position_name)) {
			echo '<div id="pos_' . $position_name . '" style="display:none">' . "\n";
			echo '	<jdoc:include type="modules" name="' . $position_name . '" style="xhtml" />' . "\n";
			echo '</div>' . "\n";
		}
	}

	function echo_pathway()
	{
		echo '<jdoc:include type="modules" name="breadcrumb" />' . "\n";
	}

	function echo_mainbody_pragma()
	{
		$var = 'mainbody_width';
		printf(
			'<div id="mainbody"%s>' . "\n",
			isset($this->$var) && !empty($this->$var) ? ' style="width:' . $this->$var . 'px"' : ''
		);
		echo '<jdoc:include type="component" />' . "\n";
		echo '</div>' . "\n";
	}

	function echo_mainbody_wrapper()
	{
		if ($this->seocp)
			echo '<div id="mainbody_area"></div>' . "\n";
		else
			$this->echo_mainbody_pragma();

		echo '<div class="clearfix"></div>' . "\n"; // fix for IE7
	}

	function echo_position($position_name, $direct = false, $clearfix = true)
	{
		if ($direct || $this->modcount($position_name)) {
			$pos_data = @$this->zl_data['regpos'][$position_name];

			if ($pos_data !== null)
				$this->echo_gstyle($pos_data['style'], 'open');

			$width = '';
			$var = 'pos_' . $position_name . '_width';
			if (isset($this->$var) && !empty($this->$var))
				$width = $this->$var;
			else if ($pos_data !== null)
				$width = $pos_data['width'];

			printf(
				'<div id="pos_%s"%s>' . "\n",
				$position_name,
				empty($width) ? '' : ' style="width:' . $width . 'px"'
			);
			echo '	<jdoc:include type="modules" name="' . $position_name . '" style="zlmod" />' . "\n";
			echo '</div>' . "\n";

			if ($pos_data !== null)
				$this->echo_gstyle($pos_data['style'], 'close');

			if ($clearfix)
				echo '<div class="clearfix"></div>' . "\n"; // fix for IE7
		}
	}

	function echo_positions()
	{
		// arguments: first is the spacer name, last is optional boolean for clearfix and the rest are position names
		$args = func_get_args();
		$count = count($args);
		$clearfix = true;

		if ($count > 0 && is_bool($args[$count - 1])) {
			$clearfix = array_pop($args);
			$count--;
		}

		if ($count < 2)
			die('Error in echo_positions(): Not enough arguments');

		$positions = array();
		for ($i = 1; $i < $count; $i++)
			if ($this->modcount($args[$i]))
				$positions[] = $args[$i];

		if (empty($positions))
			return;

		if ($count > 2)
			echo '<table cellspacing="0" cellpadding="0" width="100%"><tr>' . "\n";

		$first = true;
		foreach ($positions as $position_name) {
			if ($first)
				$first = false;
			else
				echo '<td class="gap"></td>' . "\n";

			if ($count > 2)
				echo '<td valign="top">' . "\n";

			$this->echo_position($position_name, true, $clearfix);

			if ($count > 2)
				echo '</td>' . "\n";
		}

		if ($count > 2)
			echo '</tr></table>' . "\n";

		// output spacer
		if (!empty($args[0]))
			echo '<div id="' . $args[0] . '"></div>' . "\n";
	}

	function load_menu($menu_name)
	{
		$user =& JFactory::getUser();
		$user_access = (int) $user->get('aid', 0);

		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$shownoauth = $contentConfig->get('shownoauth');

		$db =& JFactory::getDBO();
		$db->setQuery( sprintf(
			"SELECT * FROM #__menu WHERE menutype=%s AND published='1' %s ORDER BY ordering",
			$db->Quote($this->header_menu_name),
			$shownoauth ? "" : "AND access <= '$user_access'"
		) );
		$menu = $db->loadObjectList('id');

		// initialize menu tree
		$menu_base = array();
		foreach ($menu as $k => $mitem) {
			$mi = $this->load_menu_item($mitem);
			$menu[$k]->is_active = $mi['selection'] > 0;
			$menu[$k]->selection = $mi['selection'];
			$menu[$k]->type = $mi['type'];
			$menu[$k]->link = $mi['link'];
			$menu[$k]->href = $mi['href'];
			$menu[$k]->name = $mi['name'];
			$menu[$k]->image = $mi['image'];
			$menu[$k]->sub_menu_items = array();
		}

		// set tree hierarchy
		foreach ($menu as $k => $mitem) {
			if ($mitem->parent == 0)
				$menu_base[] = $k;
			else if (isset($menu[$mitem->parent]))
				$menu[$mitem->parent]->sub_menu_items[] = $k;
		}

		// prepare javascript code
		$this->menu_head_tags = array();
		$this->menu_js = '';
		if (!empty($menu_base)) {
			$stack = array('base' => $menu_base);
			while (!empty($stack)) {
				reset($stack);
				list($base, $items) = each($stack);
				array_shift($stack);

				foreach ($items as $item) {
					$mi = &$menu[$item];

					if (!empty($mi->sub_menu_items))
						$stack = array_merge($stack, array('cmi' . $item => $mi->sub_menu_items));

					if ($base == 'base') {
						$mi->head_id = 'cmi' . $item;
						$mi->full_link = $mi->href != '' ? '<a ' . $mi->href . '>' . $mi->name . '</a>' : $mi->name;
						$this->menu_head_tags[] = $mi;
						$this->menu_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', type: '%s', link: '%s', selection: %u});\n",
							'cmi' . $item,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							$mi->selection
						);
					}
					else {
						$this->menu_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', parent_id: '%s', type: '%s', link: '%s', caption: '%s', selection: %u});\n",
							'cmi' . $item,
							$base,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							json_esc(str_replace('&amp;', '&', $mi->name)),
							$mi->selection
						);
					}
				}	
			}
		}

	}

	function load_menu_item($item)
	{
		$result = array(
			'type' => 'text', // text, link, link_new, link_popup, separator
			'name' => $item->name,
			'link' => '',
			'href' => '',
			'image' => '',
			'selection' => 0, // 0 = none, 1 = parent, 2 = current
		);

		// Menu Link is a special type that is a link to another item
		if ($item->type == 'menulink') {
			$target_id = 0;

			if (!empty($item->params)) {
				$source_params = new JParameter($item->params);
				$target_id = $source_params->get('menu_item', 0);
			}

			if ($target_id == 0 && preg_match('/Itemid=([0-9]+)/', $item->link, $m))
				$target_id = intval($m[1]);

			if ($target_id > 0) {
				$menu = &JSite::getMenu();
				if ($tmp = $menu->getItem($target_id))
					$item = $tmp;
			}
		}

		static $path = false;
		if ($path === false) {
			$menu = &JSite::getMenu();
			$active = $menu->getActive();
			$path = isset($active) ? array_reverse($active->tree) : null;
		}

		if (!is_array($path) || empty($path))
			{ } // ignore cases
		else if ($path[0] == $item->id)
			$result['selection'] = 2;
		else if (in_array($item->id, $path))
			$result['selection'] = 1;

		$iParams = new JParameter($item->params);
		if ($iParams->get('menu_image') && $iParams->get('menu_image') != -1)
			$result['image'] = '<img src="'.JURI::base(true).'/images/stories/'.$iParams->get('menu_image').'" alt="" />';

		switch ($item->type) {
			case 'separator' :
				$result['type'] = 'separator';
				break;

			case 'url' :
				if ((strpos($item->link, 'index.php?') !== false) && (strpos($item->link, 'Itemid=') === false)) {
					$item->url = $item->link.'&amp;Itemid='.$item->id;
				} else {
					$item->url = $item->link;
				}
				break;

			default :
				$router = JSite::getRouter();
				$item->url = $router->getMode() == JROUTER_MODE_SEF ? 'index.php?Itemid='.$item->id : $item->link.'&Itemid='.$item->id;
				break;
		}

		// Print a link if it exists
		if ($item->type != 'separator' && $item->url != null)
		{
			// Handle SSL links
			$iSecure = $iParams->def('secure', 0);
			if ($item->home == 1) {
				$item->url = JURI::base();
			} elseif (strcasecmp(substr($item->url, 0, 4), 'http') && (strpos($item->link, 'index.php?') !== false)) {
				$item->url = JRoute::_($item->url, true, $iSecure);
			} else {
				$item->url = str_replace('&', '&amp;', $item->url);
			}

			$result['link'] = $item->url;

			switch ($item->browserNav) {
				case 1:
					// _blank
					$result['href'] = 'href="'.$item->url.'" target="_blank"';
					$result['type'] = 'link_new';
					break;

				case 2:
					// window.open
					$attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
					$link = str_replace('index.php', 'index2.php', $item->url);
					$result['href'] = 'href="'.$link.'" onclick="window.open(this.href,\'targetWindow\',\''.$attribs.'\');return false;"';
					$result['type'] = 'link_popup';
					$result['link'] = $link;
					break;

				case 0:
				default:
					// _top
					$result['href'] = 'href="'.$item->url.'"';
					$result['type'] = 'link';
					break;
			}

			if ($result['type'] == 'text')
				$result['type'] = 'link';
		}

		return $result;
	}

}

class ZoneGroupManager
{
	var $groups = array();

	function cleanup($base)
	{
		for ($i = 0, $len = count($this->groups); $i < $len; $i++)
			if (!$this->groups[$i]->cleanup($base))
				unset($this->groups[$i]);
	}
}

class ZoneGroup
{
	var $name;
	var $zones = array();

	function cleanup($base)
	{
		for ($i = 0, $len = count($this->zones); $i < $len; $i++)
			if (!$this->zones[$i]->cleanup($base))
				unset($this->zones[$i]);

		return count($this->zones) > 0;
	}
}

class Zone
{
	var $style;
	var $groups = array();

	function cleanup($base)
	{
		for ($i = 0, $len = count($this->groups); $i < $len; $i++)
			if (!$this->groups[$i]->cleanup($base))
				unset($this->groups[$i]);

		return count($this->groups) > 0;
	}
}

class PositionGroup
{
	var $name;
	var $positions = array();

	function cleanup($base)
	{
		for ($i = 0, $len = count($this->positions); $i < $len; $i++)
			if (!$this->positions[$i]->cleanup($base))
				unset($this->positions[$i]);

		return count($this->positions) > 0;
	}
}

class Position
{
	var $name, $width, $style, $collapsible;

	function cleanup($base)
	{
		return $this->name == '' || $base->modcount($this->name) || $this->collapsible == false;
	}
}


/**
 * Escapes strings to be used by JavaScript
 * 
 * @version 1.1.0.20070709
 * @author Alex Stylianos
 * @copyright Creative Pulse 2007
 * @link http://www.creativepulse.eu
 */
function json_esc($input, $esc_lt_gt = true)
{
	$result = '';
	$input = (string) $input;
	$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );

	if ($esc_lt_gt)
		$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));

	for ($i = 0, $len = strlen($input); $i < $len; $i++)
		$result .= isset($conv[$input[$i]]) ? '\\' . $conv[$input[$i]] : $input[$i];

	return $result;
}

?>