<?php

/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

defined('ZONEMANAGER') or die('Direct Access to this location is not allowed.');

require_once($dirname . '/includes/tpl_validation.php');

$templates1 = array();
$templates2 = array();

if ($dp = opendir($base_tpl_dir)) {
	while (false !== ($tpl_filename = readdir($dp))) {
		$res = validate_template($base_tpl_dir, $tpl_filename, $manager_version, $min_tpl_version, $max_tpl_version, $tpl_error, $name, $tpl_url, $gstyles);
		if ($res == TPLVAL_NOTEMPLATE)
			continue;

		if ($res == TPLVAL_INCOMPATIBLE)
			$list = &$templates2;
		else
			$list = &$templates1;

		$list[strtoupper($name)] = array(
			'tpl_filename' => $tpl_filename,
			'name' => $name,
			'error' => $tpl_error,
		);
	}
	closedir($dp);
}

echo <<<EOF
<div align="center">

<div id="zonemgr_list_logo">
	<img src="components/com_zonemgr/images/logo_list.png" alt="" />
</div>

<p>{$rcs('HD_TPL_LIST_HINT')}
	&nbsp; [<strong><a href="javascript:void(0)" onclick="window.open('$url_aux?option=com_zonemgr&amp;no_html=1&amp;task=help', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');">?</a></strong>]
	</p>
<table><tr><td>
<table class="adminlist">
	<thead>
		<tr>
			<th> &nbsp; &nbsp; </th>
			<th class="title">{$rcs('COL_TEMPLATE')}</th>
			<th> &nbsp; &nbsp; </th>
			<th class="title">{$rcs('COL_STATUS')}</th>
			<th> &nbsp; &nbsp; </th>
		</tr>
	</thead>
	<tbody>

EOF;

$fmt = <<<EOF
		<tr class="row%s">
			<td></td>
			<td>%s</td>
			<td></td>
			<td>%s</td>
			<td></td>
		</tr>

EOF;

ksort($templates1);
ksort($templates2);
$i = 0;

foreach ($templates1 as $template) {
	$i++;

	if ($template['error'] == '') {
		$name = '<a href="' . $url_main . '?option=com_zonemgr&task=edit&template=' . $template['tpl_filename'] . '">' . htmlspecialchars($template['name']) . '</a>';
		$status = '<span class="success">' . rcs('TPL_FOUND') . '</span>';
	}
	else {
		$name = htmlspecialchars($template['name']);
		$status = '<a href="javascript:void(0)" onclick="var obj=document.getElementById(\'tpl_' . $i . '\');obj.style.display=obj.style.display==\'none\'?\'block\':\'none\';"><span class="error">' . rcs($template['error']) . ' ...</span></a><div id="tpl_' . $i . '" style="display:none">' . rcs($template['error'] . '_MORE') . '</div>';
	}

	printf($fmt, $i % 2, $name, $status);
}

foreach ($templates2 as $template) {
	$i++;
	$name = htmlspecialchars($template['name']);
	$status = '<a href="javascript:void(0)" onclick="var obj=document.getElementById(\'tpl_' . $i . '\');obj.style.display=obj.style.display==\'none\'?\'block\':\'none\';"><span class="invalid_tpl">' . rcs($template['error']) . ' ...</span></a><div id="tpl_' . $i . '" style="display:none">' . rcs($template['error'] . '_MORE') . '</div>';

	printf($fmt, $i % 2, $name, $status);
}

echo <<<EOF
	</tbody>
</table>
</td></tr></table>
</div>

EOF;

if ($view_js_init != '')
	echo <<<EOF

<script type="text/javascript">
// <![CDATA[

$view_js_init

// ]]>
</script>

EOF;

require($dirname . '/includes/footer.php');

?>