<?php

/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

defined('ZONEMANAGER') or die('Direct Access to this location is not allowed.');

validate_antispoof_value();

class ZoneGroupManager
{
	var $groups = array();

	function ZoneGroupManager($avail_groups, $zones)
	{
		$this->__construct($avail_groups, $zones);
	}

	function __construct($avail_groups, $zones)
	{
		$i = -1;
		foreach ($zones as $zone) {
			$group_name = in_array($zone['group'], $avail_groups) ? $zone['group'] : '';
			if ($i == -1 || $this->groups[$i]->name != $group_name) {
				$this->groups[] = new ZoneGroup($group_name);
				$i++;
			}
			$this->groups[$i]->add_zone($avail_groups, $zone);
		}
	}
}

class ZoneGroup
{
	var $name;
	var $zones = array();

	function ZoneGroup($name)
	{
		$this->__construct($name);
	}

	function __construct($name)
	{
		$this->name = $name;
	}

	function add_zone($avail_groups, $zone)
	{
		$this->zones[] = new Zone($avail_groups, $zone);
	}
}

class Zone
{
	var $style;
	var $groups = array();

	function Zone($avail_groups, $zone)
	{
		$this->__construct($avail_groups, $zone);
	}

	function __construct($avail_groups, $zone)
	{
		$this->style = $zone['style'];

		$i = -1;
		foreach ($zone['pos'] as $pos) {
			$group_name = in_array($pos['group'], $avail_groups) ? $pos['group'] : '';
			if ($i == -1 || $this->groups[$i]->name != $group_name) {
				$this->groups[] = new PositionGroup($group_name);
				$i++;
			}
			$this->groups[$i]->add_position($pos);
		}
	}
}

class PositionGroup
{
	var $name;
	var $positions = array();

	function PositionGroup($name)
	{
		$this->__construct($name);
	}

	function __construct($name)
	{
		$this->name = $name;
	}

	function add_position($position)
	{
		$this->positions[] = new Position($position);
	}
}

class Position
{
	var $name, $width, $style, $collapsible;

	function Position($position)
	{
		$this->__construct($position);
	}

	function __construct($position)
	{
		$this->name = $position['name'];
		$this->width = $position['width'];
		$this->style = $position['style'];
		$this->collapsible = $position['collapsible'] != 'false';
	}
}

$tpl_dir = $base_tpl_dir . '/' . $_POST['tpl_filename'];
$conf_file = $tpl_dir . '/zl_config.php';
$xml_file = $tpl_dir . '/templateDetails.xml';

$vars['gapsz'] = $_POST['gapsz'];
$vars['total_width'] = $_POST['total_width'];
$vars['zones'] = $_POST['zones'];
$vars['regpos'] = isset($_POST['regpos']) ? $_POST['regpos'] : array();
$vars['groups'] = isset($_POST['groups']) ? $_POST['groups'] : array();

// cache serialized version of organized zones and positions
$zones_obj = new ZoneGroupManager(array_keys($vars['groups']), $vars['zones']);
$vars['zones_obj'] = serialize($zones_obj);

// save useful variables
if ($fp = @fopen($conf_file, 'w')) {
	fwrite($fp, "<?php die('Direct Access to this location is not allowed.'); ?>");
	fwrite($fp, serialize($vars));
	fclose($fp);
}
else {
	hd_exit(rcs('ERROR_WRITING_TEMPLATE'));
}

if ($software_version == 'j15') {
	// save Joomla 1.5 position names

	$positions = '	<positions>' . "\n";

	$reserved_positions = isset($_POST['reserved_positions']) ? $_POST['reserved_positions'] : array();
	foreach (explode(',', $reserved_positions) as $position)
		$positions .= '		<position>' . $position . '</position>' . "\n";

	foreach ($vars['zones'] as $zone)
		foreach ($zone['pos'] as $pos)
			if ($pos['name'] != '')
				$positions .= '		<position>' . $pos['name'] . '</position>' . "\n";

	$positions .= '	</positions>';

	if ($fp = @fopen($xml_file, 'r+')) {
		$contents = preg_replace('~\t*<positions>.*</positions>~s', $positions, fread($fp, filesize($xml_file)));
		fseek($fp, 0);
		ftruncate($fp, 0);
		fwrite($fp, $contents);
		fclose($fp);
	}
	else {
		hd_exit(rcs('ERROR_READWRITE_TEMPLATE_XML'));
	}
}

?>